-- Фунция бинарного поиска.
return {BinSearch = function(a_aIndex, a_AsKey, a_lCaseSensitive, a_lExact, a_cmpFunc)
  local function cmpCaseSens(par1, par2)
   if par1 < par2 then return -1
   elseif par1 > par2 then return 1
   else return 0
   end
  end
  local function cmpCaseInsens(par1, par2)
   return cmpCaseSens(mf.lcase(par1), mf.lcase(par2))
  end
  local aIndex, AsKey, lCaseSensitive, lExact
  if type(a_aIndex.Where) == 'table' then
   aIndex = a_aIndex.Where
   AsKey = a_aIndex.What
   lExact = a_aIndex.Exact
   lCaseSensitive = a_aIndex.CaseSensitive
  else
   aIndex = a_aIndex
   AsKey = a_AsKey
   lExact = a_lExact
   lCaseSensitive = a_lCaseSensitive
  end
  local cmpFunc = a_cmpFunc or (lCaseSensitive and cmpCaseSens or cmpCaseInsens)
  local i1, i2, i=1,#aIndex
  local sKey = lCaseSensitive and AsKey or mf.lcase(AsKey)
  -- Поиск регистронезависимый
  while i2 > i1 do
   if i2-i1==1 then
    if cmpFunc(aIndex[i1], sKey) == 0 then
     --i=i1
     return i1, aIndex[i1]
    elseif cmpFunc(aIndex[i2], sKey) == 0 then
     --i=i2
     return i2, aIndex[i2]
    else
     --i = -1
     if lExact then
      return
     else
      return i2, aIndex[i2]
     end
    end
   end
   i = math.floor( (i1+i2)/2 )
   local cmp= cmpFunc(aIndex[i], sKey)
   if cmp < 0 then
    i1 = i
   elseif cmp > 0 then
    i2 = i
   else
    while i>1 and cmpFunc(aIndex[i-1], sKey) == 0 do
     i = i - 1
    end
    return i,aIndex[i]
   end
  end
end -- BinSearch
}