local Info = Info or package.loaded.regscript or function(...) return ... end --luacheck: ignore 113/Info
local nfo = Info {_filename or ...,
  name          = "SearchTmpPanel";
  description   = "Панель результатов поиска";
  version       = "1.0.1"; --http://semver.org/lang/ru/
  author        = "IgorZ";
--  url           = "http://forum.farmanager.com/viewtopic.php?t=11605";
  id            = "";
  minfarversion = {3,0,0,5182,0};
  files         = "*Eng.hlf;*Rus.hlf;*Eng.lng;*Rus.lng";
  helptxt       = [[
Скрипт является панельным модулем, предназначенным заменять временную панель при выводе результатов поиска файлов.
Основное отличие - форма вывода информации, максимально приближённая к формату результатов поиска в диалоге поиска Far.
Запуск:
  - путём нажатия на кнопку [ Панель ] диалога поиска файлов;
  - путём выбора пункта "Панель результатов поиска файлов" из меню плагинов Far (только если на активной панели Far открыта временная панель);
  - с помощью клавиатурной комбинации CtrlShiftT (только если на активной панели Far открыта временная панель).
]];
history         = [[
2019/04/26 v1.0   - Первый релиз.
2019/04/29 v1.0.1 - Исправлена ошибка в языковых файлах. Добавлена независимость от расширения файла.
]];
}
if not nfo then return end
----------------------------------------------------------------------------------------------------
--                Для включения на временную панель файлов, входящих в архив                      --
----------------------------------------------------------------------------------------------------
local F = far.Flags
local G = far.Guids
local FindFileId, FindFileResultId = win.Uuid(G.FindFileId), win.Uuid(G.FindFileResultId)
local InArc = false
local GetMsgEx = require"BAX.GetMsg"
local BaxUtils = require"BAX.BaxUtils"
local TabUtils=require"BAX.TabUtils"
local aAdd={}
if GetMsgEx then

local Lang, FindArchives, FindPanel =
      Far.GetConfig('Language.Main'), -- Чтоб не перечитывать, если язык не поменялся
      GetMsgEx('%FARHOME%\\far', 'MFindArchives'),
      GetMsgEx('%FARHOME%\\far', 'MFindPanel')
Event {
  id = "3FADC391-AC06-49CB-8462-5071C60090DE";
  group       = "DialogEvent";
  description = "Запоминание факта, что флаг\"Искать в архивах\" установлен";
--  filemask    = "*.txt,*.cpp";                          -- string (опциональное поле)
--  priority    = 50;                                     -- number (опциональное поле)
  condition   = function(Event, Param)

   if Event==F.DE_DLGPROCEND and Param.Msg==F.DN_CLOSE then
    local hDlg = Param.hDlg
    local DlgId = (hDlg:send(F.DM_GETDIALOGINFO) or {}).Id
    if DlgId == FindFileId then
     do
      local lang = Far.GetConfig('Language.Main')
      if Lang ~= lang then
       Lang, FindArchives, FindPanel =
        lang,
        GetMsgEx('%FARHOME%\\far', 'MFindArchives'),
        GetMsgEx('%FARHOME%\\far', 'MFindPanel')
      end
     end
     for iItem=1,Dlg.ItemCount do
      local Item=hDlg:send(F.DM_GETDLGITEM, iItem)
      if Item[1] == F.DI_CHECKBOX or Item[1] == "DI_CHECKBOX" then
       if Item[10] == FindArchives then
        InArc = Item[6] == 1
       end
      end
     end -- for iItem
    end
   end
  end;
  action      = function(Event, Param) end;
}

Event {
  id = "72F629FA-A254-4E64-8C30-A3A7D7489EA0";
  group       = "DialogEvent";
  description = "Занесение найденных файлов во временную панель";
  condition   = function(Event, Param)
   local hDlg = Param.hDlg
   local DlgId = (hDlg:send(F.DM_GETDIALOGINFO) or {}).Id
   if DlgId==FindFileResultId then
    if InArc and Event == F.DE_DLGPROCEND and Param.Msg == F.DN_CLOSE then
     InArc = false
     if Param.Param1 and hDlg:send(F.DM_GETTEXT, Param.Param1) == FindPanel then
      aAdd={}
      for iItem=1, Dlg.ItemCount do
       local Item=hDlg:send(F.DM_GETDLGITEM, iItem)
       if Item[1] == F.DI_LISTBOX or Item[1] == "DI_LISTBOX" then
        local FoundFiles = Item[6]
        local HostFile = ''
        local aNames={'sDate','Size','Attr','Name'}
        for i,v in ipairs(FoundFiles) do
         local Text = v.Text:match"^%s*(.-)%s*$" -- => trim
         if band(v.Flags, F.LIF_SEPARATOR) == 0 then
          if Text:match("^%a:%\\") then
           if Text:find(':', 3, true) then
            HostFile = Text .. (Text:sub(-1) == '\\' and '' or '\\')
           else
            HostFile = ''
           end
          elseif HostFile ~= '' then
            local aFile, iFile={}, 0
            for w in  (v.Text .. '│'):gmatch("([^│]*)%│") do
             iFile = iFile + 1
             aFile[aNames[iFile]] = mf.trim(w)
            end
            aFile.HostFile = HostFile:match("^(.*:.*):")
            aFile.FullName = HostFile .. aFile.Name
            aFile.Date = BaxUtils.StrToDate(aFile.sDate)
            aFile.Size = tonumber(aFile.Size)
            aFile.Attr = (aFile.Attr:upper():find('U') and '' or 'U') .. aFile.Attr
            table.insert(aAdd, aFile)
          end
         end
        end -- for i,v in ipairs(FoundFiles) do
       end -- if Item[1] == F.DI_LISTBOX or Item[1] == "DI_LISTBOX" then
      end
      table.sort(aAdd, function (v1, v2)
                        if v1.HostFile ~= v2.HostFile then return v1.HostFile < v2.HostFile
                        else return v1.Name < v2.Name end
                       end
                )
     end
     return false
     --return Param.Param1 and hDlg:send(F.DM_GETTEXT, Param.Param1) == FindPanel
    end
   end
  end;
  action      = function()  end;
}
end -- if GetMsgEx
----------------------------------------------------------------------------------------------------
--                Конец включения на временную панель файлов, входящих в архив                      --
----------------------------------------------------------------------------------------------------


-- +
--[[константы]]
-- -
--local F,Author,ConfPart = far.Flags,nfo.author,nfo.name
local Author,ConfPart = nfo.author,nfo.name
local Guids = {
  TPGuid = "B77C964B-E31E-4D4C-8FE5-D6B0C6853E7C", -- временная панель Far
  LMGuid = "4EBBEFC8-2084-4B7F-94C0-692CE136894D", -- LuaMacro
  PMGuid = win.Uuid("BA461384-095B-4D0F-AA87-07365A0E2AF6"), -- панельный модуль
  MIGuid = "729E0E44-73DC-4D87-9E30-0769572C2627", -- пункт меню плагинов
  MaGuid = "2ADA3C33-D955-48B3-AC45-329A8A135D03", -- макрос
  CDGuid = win.Uuid("97E5867F-701F-4640-AA95-DF021B9A2B57"), -- панельный модуль
}
local PathName = debug.getinfo(function()end).source:match("^@?([^@].*)%.%a+$") -- путь и имя без расширения
local Def = { -- настройки по умолчанию
  CopyToTmpPanel = 1, -- копировать список во временную панель
  OpenTmpPanel = 1, -- открыть временную панель со списком файлов на пассивной панели
}
--local DefProfile = F.PSL_LOCAL -- место хранения настроек по умолчанию: локальные
local DefProfile = F.PSL_ROAMING -- место хранения настроек по умолчанию: глобальные
-- +
--[[переменные]]
-- -
local DirSortMode,S,L,UsedProfile -- "каталоги первые" в предыдущей панели, настройки, язык, профиль с настройками
-- +
--[=[вспомогательные функции]=]
-- -
local LoadLang,LoadSettings,SaveSettings,ShowHelp
-- +
--[==[Основные функции]==]
-- -
local Config
--
function LoadLang() --[[загрузить настройки языка]]
local FL,dummy = Far.GetConfig("Language.Main"):sub(1,3),function() return {"Cannot find languages files"} end -- язык, пустая функция
if not L or L.Lang~=FL then L = (loadfile(PathName..FL..".lng") or loadfile(PathName.."Eng.lng") or dummy)() end -- обновим, если язык другой
end --LoadLang
--
function LoadSettings(ForceDef) --[[загрузить настройки из БД]]
local obj = far.CreateSettings(nil,DefProfile) -- откроем предпочтительные настройки
local key = obj:OpenSubkey(obj:OpenSubkey(0,Author) or 0,ConfPart) -- есть раздел?
UsedProfile = DefProfile -- запомним профиль
if not key then -- настроек нет?
  obj:Free() obj = far.CreateSettings(nil,DefProfile==F.PSL_LOCAL and F.PSL_ROAMING or F.PSL_LOCAL) -- откроем другие настройки
  key = obj:OpenSubkey(obj:OpenSubkey(0,Author) or 0,ConfPart) -- есть раздел? если нет, неважно, какой открыт, всё равно брать умолчания
  if key then UsedProfile = DefProfile==F.PSL_LOCAL and F.PSL_ROAMING or F.PSL_LOCAL end -- из другого профиля открылись? запомним профиль
end
local function L1(n) return not ForceDef and obj:Get(key or -1,n,type(Def[n])=="string" and F.FST_STRING or F.FST_QWORD) or Def[n] end
S = { CopyToTmpPanel = L1("CopyToTmpPanel")~=0,OpenTmpPanel = L1("OpenTmpPanel")~=0, } -- считаем настройки
obj:Free() -- приберёмся
LoadLang() -- загрузим язык
end --LoadSettings
--
function SaveSettings() --[[сохранить настройки в БД]]
if UsedProfile==F.PSL_LOCAL then win.CreateDir(win.GetEnv("FARLOCALPROFILE").."\\PluginsData") end -- создадим папку для локальных настроек, если надо
local obj = far.CreateSettings(nil,UsedProfile) -- откроем ранее прочитанные или предпочтительные настройки
local key = obj:CreateSubkey(obj:CreateSubkey(0,Author),ConfPart) -- откроем/создадим раздел
local function S1(n,v) if v==nil then v=S[n] end; if v==nil then obj:Delete(key,n) return end; v = v==true and 1 or v==false and 0 or v
                       local t = type(v)=="string" and F.FST_STRING or F.FST_QWORD; if obj:Get(key,n,t)~=v then obj:Set(key,n,t,v) end end
S1("CopyToTmpPanel") S1("OpenTmpPanel") -- сохраним
obj:Free() -- приберёмся
end --SaveSettings
--
function ShowHelp(text) --[[Вывести справку]]
local HL = Far.GetConfig("Language.Help"):sub(1,3) -- язык (первые 3 буквы)
far.ShowHelp(PathName..(win.GetFileAttr(PathName..HL..".hlf") and HL or "Eng")..".hlf",text,F.FHELP_CUSTOMFILE) -- выведем
end --ShowHelp
--
if type(nfo)=="table" then nfo.help = function() ShowHelp() end end
-- +
--[[настройка]]
-- -
function Config()
--
LoadLang() if not L.Lang then return far.Message(L[1],nfo.name,";Ok","w") end -- нет языковой информации - скажем и выйдем
if not S then LoadSettings() end -- загрузим настройки, если надо
--
local function DlgProc(hDlg,Msg,Param1,Param2) -- обработка событий диалога
if Msg==F.DN_BTNCLICK and Param1==2 then -- переключение работы со скрытыми панелями?
  hDlg:send(F.DM_SHOWITEM,3,Param2) -- установим видимость зависимого чекбокса
elseif (Msg==F.DN_CONTROLINPUT and (Param2.VirtualKeyCode==0x70 and band(Param2.ControlKeyState,0x1f)==0))or(Msg==F.DN_BTNCLICK and Param1==07) then
  ShowHelp("Config") -- F1 или нажата кнопка справки
end
end
--
local form = { -- диалог настройки конфигурации
--[[01]] {F.DI_DOUBLEBOX, 3, 1,51, 6,0,0,0,0,L.diConf.Hdr},
--[[02]] {F.DI_CHECKBOX,  5, 2, 0, 2,S.CopyToTmpPanel and 1 or 0,0,0,0,L.diConf.CopyToTmpPanel},
--[[03]] {F.DI_CHECKBOX,  9, 3, 0, 3,S.OpenTmpPanel and 1 or 0,0,0,0,L.diConf.OpenTmpPanel},
--[[04]] {F.DI_TEXT,     -1, 4, 0, 4,0,0,0,F.DIF_SEPARATOR,""},
--[[05]] {F.DI_BUTTON,    0, 5, 0, 5,0,0,0,F.DIF_DEFAULTBUTTON+F.DIF_CENTERGROUP,L.OK},
--[[06]] {F.DI_BUTTON,    0, 5, 0, 5,0,0,0,F.DIF_CENTERGROUP,L.Cancel},
--[[07]] {F.DI_BUTTON,    0, 5, 0, 5,0,0,0,F.DIF_CENTERGROUP+F.DIF_BTNNOCLOSE,L.Help},
}
-- начало кода функции
if far.Dialog(Guids.CDGuid,-1,-1,55,7,nil,form,nil,DlgProc)~=05 then return false,L.er.Cancel end -- вызовем диалог, не "ОК" - уйдём
S = { CopyToTmpPanel = form[2][6]==1, OpenTmpPanel = form[3][6]==1, } -- новые настройки
SaveSettings() -- запомним
end
--
if type(nfo)=="table" then nfo.config = Config end
--
LoadSettings() -- загрузим настройки
-- +
--[[Панельный модуль]]
-- -
local PM = {
  Info={ --[[информация о модуле]]
    Guid=Guids.PMGuid;
    Title=L.Title;
    Description=L.Desc;
    Version=nfo.version;
    Author=nfo.author;
  };
--
  Open=function(OpenFrom) --[[открыть панель]]
  if OpenFrom==F.OPEN_FINDLIST then -- открываем из диалога поиска?
    DirSortMode = band(panel.GetPanelInfo(nil,1).Flags,F.PFLAGS_DIRECTORIESFIRST)~=0 -- запомним состояние сортировки каталогов активной панели
    return {} -- приготовим объект
  end
  end;
--
  SetFindList=function(object,_,Items) --[[получить список файлов из диалога поиска]]
  local fn = far.MkTemp() -- имя для временного файла
  local h = io.open(fn,"w") -- откроем для записи
  for _,nm in ipairs(Items) do h:write(nm.FileName.."\n") end -- запишем все имена файлов
  h:close() -- закроем
  if S.CopyToTmpPanel then -- копировать файлы на временную панель?
    far.MacroPost('Keys"Tab" Plugin.Command("'..Guids.TPGuid..'",[[ +replace -menu '..fn.. -- скопируем и откроем, если надо
                  ']]) if Area.Dialog then Keys"Enter" end Keys"'..(S.OpenTmpPanel and "" or "Enter ")..'Tab"')
  end
  object.List = Items -- заполним панель списком файлов
  return true -- всё сделали
  end;
--
  GetFindData=function (object)--[[передать данные с панели Far-у]]
  local Items,pdir = {},":" -- список, каталог с прошлого шага цикла
  local function CmpFunc(v1, v2)
   if v1.HostFile:lower() < v2:lower() then return -1
   elseif v1.HostFile:lower() > v2:lower() then return 1
   else return 0 end
  end
  local hFilter = far.CreateFileFilter(1, F.FFT_PANEL)
  local NewItem
  for _,PI in ipairs(object.List) do -- переберём все элементы с панели
    local FT = win.FileTimeToSystemTime(win.FileTimeToLocalFileTime(PI.LastWriteTime)) -- преобразуем время для вывода
    local cdir = PI.FileAttributes:match("d") and PI.FileName or PI.FileName:match("^(.*)\\[^\\]*$") -- каталог файла (для каталога он сам)
    if (not PI.FileAttributes:match("d")) and (cdir~=pdir) then -- если не каталог, и предыдущий файл был в другом каталоге,
      Items[#Items+1] = win.GetFileInfo(cdir) -- получим информацию о каталоге текущего файла и добавим её в список
      Items[#Items].FileName,Items[#Items].CustomColumnData = cdir,{cdir} -- скорректируем имя для вывода Far-ом
    end
    pdir = cdir -- запомним каталог текущего файла
    NewItem = { -- запишем информацию о файле в срписок
      LastWriteTime = PI.LastWriteTime,
      LastAccessTime = PI.LastAccessTime,
      CreationTime = PI.CreationTime,
      ChangeTime = PI.ChangeTime,
      FileSize = PI.FileSize,
      AllocationSize = PI.AllocationSize,
      FileName = PI.FileName,
      AlternateFileName = PI.AlternateFileName,
      FileAttributes = PI.FileAttributes,
      Flags = PI.Flags,
      NumberOfLinks = PI.NumberOfLinks,
      CRC32 = PI.CRC32,
      Description = PI.Description,
      Owner = PI.Owner,
      CustomColumnData = {PI.FileAttributes:match("d") and PI.FileName or ([[%7d.%02d.%4d%3d:%02d:%02d│%13d│%-6s│%s]]): -- это для вывода на экран
        format(FT.wDay,FT.wMonth,FT.wYear,FT.wHour,FT.wMinute,FT.wSecond,PI.FileSize,PI.FileAttributes:upper(),PI.FileName:match("[^\\]*$"))},
      UserData = PI.UserData,
    }
    if not hFilter or hFilter:IsFileInFilter(NewItem) then
     Items[#Items+1] = NewItem
    end
    if #aAdd > 0 then
      local ii = TabUtils.BinSearch(aAdd, PI.FileName, --[[a_lCaseSensitive]]false, --[[a_lExact]]true, --[[a_cmpFunc]]CmpFunc)
      if ii then
        for iAdd=ii, #aAdd do
          if aAdd[iAdd].HostFile:lower() ~= PI.FileName:lower() then break end
          local v = aAdd[iAdd]
          local CustomColumnData = {([[  ►  %-19s│%13d│%-6s│%s]]):format(v.sDate,v.Size,v.Attr,v.FullName:sub(v.HostFile:len()+2))} -- dd.mm.yy hh:mm:ss
          NewItem = {
             LastWriteTime = v.Date;
             LastAccessTime = v.Date;
             CreationTime = v.Date;
             ChangeTime = v.Date;
             FileSize = v.Size,
          --   AllocationSize = nSize,
             FileName = '►' .. v.Name,
             AlternateFileName = '►' .. v.FullName,
             FileAttributes = v.Attr,
          --   --Flags = PI.Flags,
          --   --NumberOfLinks = PI.NumberOfLinks,
          --   --CRC32 = PI.CRC32,
          --   --Description = PI.Description,
          --   --Owner = PI.Owner,
             CustomColumnData = CustomColumnData;
          --   --UserData = PI.UserData,
          }
          if not hFilter or hFilter:IsFileInFilter(NewItem) then
           Items[#Items+1] = NewItem
          end
        end -- for iAdd
      end -- if ii
    end -- if #aAdd > 0
  end -- for _,PI in ipairs(object.List)
  if hFilter then hFilter:FreeFileFilter() end
  return Items -- передадим список Far-у
  end; -- of function GetFindData
--
  GetOpenPanelInfo=function() --[[отдать Far-у информацию о панели]]
  return {
    Flags = F.OPIF_DISABLEFILTER+F.OPIF_DISABLESORTGROUPS+F.OPIF_ADDDOTS+F.OPIF_REALNAMES, -- отключим фильтры, группы сортировки, добавим ".."
    PanelTitle = L.Title, -- заголовок панели
    PanelModesArray = {{ -- единственный режим колонок
      ColumnTypes = "C0", -- пользовательская колонка
      ColumnWidths = "0", -- на всю панель
      ColumnTitles = {L.ColumnName}, -- заголовок колонки
      StatusColumnTypes = "N", -- в статусной строке - имя
      StatusColumnWidths = "0", -- на всю панель
      Flags = F.PMFLAGS_FULLSCREEN, -- панель занимает весь экран
    }};
    PanelModesNumber = 1; -- количество переопределённых режимов
    StartPanelMode = "1"; -- активный режим (наш единственный)
    StartSortMode = F.SM_UNSORTED; -- не сортировать
    StartSortOrder = 0; -- не инвертировать порядок элементов в списке
  }
  end;
--
  ProcessPanelEvent=function(_,_,Event) --[[обработчик событий панели]]
  if Event==F.FE_GOTFOCUS then panel.SetDirectoriesFirst(nil,1) end -- при получении панелью фокуса запретим "каталоги вперёд"
  return false -- и пусть Far всё события сам обработает
  end;
--
  ProcessPanelInput=function(_,_,rec) --[[обработчик нажатий клавиш и т. п.]]
if rec.EventType==F.KEY_EVENT then
  if rec.VirtualKeyCode==0x78 and band(rec.ControlKeyState,0x03)>0 and band(rec.ControlKeyState,0x10)>0 then --AltShiftF9
    Config() -- выведем диалог настроек
    return true -- и всё на этом
  elseif rec.VirtualKeyCode==0x70 and band(rec.ControlKeyState,0x1f)==0 then --F1
    ShowHelp("Main") -- F1 или нажата кнопка справки
    return true -- и всё на этом
  end
end
return false -- остальное пусть Far сам обработает
  end;
--
  ClosePanel=function() --[[закрытие панели]]
  panel.SetDirectoriesFirst(nil,1,DirSortMode) -- при закрытии вернём старый порядок сортировки каталогов
  end;
}
--
PanelModule(PM) -- зарегистрируем панельный модуль
-- +
--[[Пункт меню]]
-- -
MenuItem{
  guid=Guids.MIGuid; menu="Plugins Config"; area="Shell"; description=L.Desc;
  text=function(menu) -- выводим пункт только из временной панели и в меню конфигурации
  if menu=="Config" or(APanel.Plugin and panel.GetPanelInfo(nil,1).OwnerGuid==win.Uuid(Guids.TPGuid)) then return L.Desc end
  end;
  action=function(OpenFrom)
  if OpenFrom then -- открыли панель?
    local Items = {} -- список элементов
    for i = 2,panel.GetPanelInfo(nil,1).ItemsNumber do Items[#Items+1] = panel.GetPanelItem(nil,1,i) end -- заполним его элементами временной панели
    return PM,{FromTP=true,List=Items} -- запустим панель
  else -- настройки?
    Config() -- вызовем диалог
  end
 end;
}
-- +
--[[Макрос вызова]]
-- -
Macro{
  id=Guids.MaGuid; area="Shell"; key="CtrlShiftT"; description=L.Desc; flags="NoFilePanels";
  condition=function() return panel.GetPanelInfo(nil,1).OwnerGuid==win.Uuid(Guids.TPGuid) end; -- работаем только из временной панели
  action=function() Plugin.Menu(Guids.LMGuid,Guids.MIGuid) end; -- вызовем пункт меню плагинов
}
